const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const activity_logs = sequelize.define(
    'activity_logs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

entity_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"purchase_requisition",


"purchase_order",


"goods_receipt",


"vendor_invoice",


"payment",


"document",


"product",


"vendor"

        ],

      },

entity_reference: {
        type: DataTypes.TEXT,
      
      

      },

action: {
        type: DataTypes.ENUM,
      
      

        values: [

"created",


"updated",


"submitted",


"approved",


"rejected",


"sent",


"posted",


"received",


"paid",


"archived",


"commented",


"attached_file"

        ],

      },

event_time: {
        type: DataTypes.DATE,
      
      

      },

message: {
        type: DataTypes.TEXT,
      
      

      },

ip_address: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  activity_logs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.activity_logs.belongsTo(db.users, {
      as: 'actor',
      foreignKey: {
        name: 'actorId',
      },
      constraints: false,
    });

    db.activity_logs.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.activity_logs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.activity_logs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return activity_logs;
};


